local assets = {
	Asset("ANIM", "anim/ir_items.zip"),
}

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	MakeInventoryPhysics(inst)
	
	inst.AnimState:SetBank("ir_items")
	inst.AnimState:SetBuild("ir_items")
	inst.AnimState:PlayAnimation("coal")
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "coalore"
	inst.components.inventoryitem.atlasname = "images/coalore.xml"
	
	inst:AddComponent("stackable")
	
    inst:AddComponent("edible")
    inst.components.edible.foodtype = "ELEMENTAL"
    inst.components.edible.hungervalue = 3
    inst.components.edible.healthvalue = -1
    inst:AddComponent("tradable")
	
	inst:AddComponent("fuel")
	inst.components.fuel.fuelvalue = TUNING.MED_LARGE_FUEL
	
	if IsDLCEnabled(CAPY_DLC) then
		MakeBlowInHurricane(inst, TUNING.WINDBLOWN_SCALE_MIN.MEDIUM, TUNING.WINDBLOWN_SCALE_MAX.MEDIUM)
	end
	
	MakeSmallBurnable(inst,20)
	MakeSmallPropagator(inst)
	
	inst:AddTag("coal")
	
	return inst
end


return Prefab("common/inventory/coalore",fn,assets)