--coal is found in default boulders
if LootTables and LootTables.rock1 then
	--table.insert(LootTables.rock1,{'quartzsand',.7})
	table.insert(LootTables.rock1,{'coalore', .8})
	table.insert(LootTables.rock1,{'coalore', .2})
end

--coal also drops from Krampus instead of charcoal
if LootTables and LootTables.krampus then
	for i, t in pairs(LootTables.krampus) do
		if t[1] and t[1] == "charcoal" then
			t[1] = "coalore"
		end
	end
end

--silver and quartzsand have its own boulder
local assets =
{
	Asset("ANIM", "anim/rock_silver.zip"),
	Asset("ANIM", "anim/rock_flintless.zip"),
}

local prefabs =
{
	"rocks",
	"quartzsand",
	"silvernugget",
}

SetSharedLootTable("rock_silver",
{
    {'rocks',     	1},
    {'rocks',     	1},
    {'rocks',     	1},
    {'silvernugget',  1},
    {'silvernugget',  .25},
	{'quartzsand',	.7},
	{'quartzsand',	.2},
})

local function OnWork(inst, worker, workleft)
	
	if workleft <= 0 then
		inst.SoundEmitter:PlaySound("dontstarve/wilson/rock_break")
		inst.components.lootdropper:DropLoot(inst:GetPosition())
		inst:Remove()
	else
		if workleft < TUNING.ROCKS_MINE*(1/3) then
			inst.AnimState:PlayAnimation("low")
		elseif workleft < TUNING.ROCKS_MINE*(2/3) then
			inst.AnimState:PlayAnimation("med")
		else
			inst.AnimState:PlayAnimation("full")
		end
	end
end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("rock_flintless")
	inst.AnimState:SetBuild("rock_silver")
	inst.AnimState:PlayAnimation("full")
	
	MakeObstaclePhysics(inst, 1.)
	
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon("rock_flintless.png")

	inst:AddComponent("lootdropper")
	inst.components.lootdropper:SetChanceLootTable("rock_silver")
	
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.MINE)
	inst.components.workable:SetWorkLeft(TUNING.ROCKS_MINE)
	
	inst.components.workable:SetOnWorkCallback(OnWork)     

	local color = 0.6 + math.random() * 0.4
	inst.AnimState:SetMultColour(color, color, color, 1)    

	inst:AddComponent("inspectable")
	inst.components.inspectable.nameoverride = "ROCK"
	MakeSnowCovered(inst, .01)        

	return inst
end

return Prefab("forest/objects/rocks/rock_silver",fn,assets,prefabs)