local assets = {
	Asset("ANIM", "anim/ir_items.zip"),
}

local function common()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("ir_items")
	inst.AnimState:SetBuild("ir_items")
	
    MakeInventoryPhysics(inst)
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	
    inst:AddComponent("stackable")
	
    inst:AddComponent("edible")
    inst.components.edible.foodtype = "ELEMENTAL"
    inst.components.edible.hungervalue = 2
    inst.components.edible.healthvalue = 5
    inst:AddComponent("tradable")
	
	inst:AddComponent("repairer")
	inst.components.repairer.repairmaterial = "metal"
	
	inst:AddTag("metal")
	inst:AddTag("silver")
	
	return inst
end

local function fn()
	local inst = common()
	
	--inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
	
	inst.AnimState:PlayAnimation("silver")
	inst.components.inventoryitem.atlasname = "images/silvernugget.xml"
	
	inst.components.repairer.healthrepairvalue = 230
	inst.components.repairer.workrepairvalue = 2
	inst.components.repairer.perishrepairvalue = .4
	
	inst:AddComponent("bait")
	
	if PrefabExists("extractor") then
		inst:AddComponent("extractable")
        inst.components.extractable.product = "goldnugget"
	end
	
	if IsDLCEnabled(CAPY_DLC) then
		MakeBlowInHurricane(inst, TUNING.WINDBLOWN_SCALE_MIN.MEDIUM, TUNING.WINDBLOWN_SCALE_MAX.MEDIUM)
	end
	
    inst:AddTag("molebait")
	
	return inst
end

local function fn2()
	local inst = common()
	
	inst.AnimState:PlayAnimation("wire")
	inst.components.inventoryitem.atlasname = "images/silverwire.xml"
	
	inst.components.repairer.healthrepairvalue = 480
	inst.components.repairer.workrepairvalue = 4
	inst.components.repairer.perishrepairvalue = .7
	
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	inst.components.tradable.goldvalue = 2
	
	if IsDLCEnabled(CAPY_DLC) then
		--MakeInventoryFloatable(inst, "wire", "wire")
		MakeBlowInHurricane(inst, TUNING.WINDBLOWN_SCALE_MIN.MEDIUM, TUNING.WINDBLOWN_SCALE_MAX.MEDIUM)
	end
	
	inst:AddTag("wire")
	
	return inst
end

return Prefab("common/inventory/silvernugget",fn,assets),
		Prefab("common/inventory/silverwire",fn2,assets)