local assets = {
	Asset("ANIM", "anim/ir_items.zip"),
	Asset("ATLAS", "images/chip.xml"),
	Asset("IMAGE", "images/chip.tex"),
}

local function commonfn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
    MakeInventoryPhysics(inst)
	
	inst.AnimState:SetBank("ir_items")
	inst.AnimState:SetBuild("ir_items")
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	
	if IsDLCEnabled(CAPY_DLC) then
		MakeBlowInHurricane(inst, TUNING.WINDBLOWN_SCALE_MIN.HEAVY, TUNING.WINDBLOWN_SCALE_MAX.HEAVY)
	end
	
	inst:AddTag("IRupgrade")
	
	return inst
end

local function speedfn()
	local inst = commonfn()
	
	inst.AnimState:PlayAnimation("upg1")
	inst.components.inventoryitem.imagename = "chip_speed"
	inst.components.inventoryitem.atlasname = "images/chip.xml"	
	
	inst.type = "speed"
	
	return inst
end

local function cheapfn()
	local inst = commonfn()
	
	inst.AnimState:PlayAnimation("upg2")
	inst.components.inventoryitem.imagename = "chip_cheap"
	inst.components.inventoryitem.atlasname = "images/chip.xml"
	
	inst.type = "cheap"
	
	return inst
end

--[[
local function trycharge(inst)
print("periodic")
	if inst.components.container then
		for k,v in pairs(inst.components.container.slots) do
			if v.components.fueled and v.components.fueled:GetPercent() < 1 then
				print("got space")
				local total = v.components.fueled.maxfuel - v.components.fueled.currentfuel
				for guid,ent in pairs(Ents) do
					if ent.components.electric and ent.components.upgradeslot
					and ent.components.upgradeslot.upgrade == "void" then
					print("fellow", ent)
						local val = math.max(0,math.min(total,ent.components.electric.current))
						print(val)
						ent.components.electric:DoDelta(-val)
						v.components.fueled:DoDelta(val)
						total = total - val
						
						if total <= 0 then
							return true
						end
					end
				end
			end
		end
	end
end

local function dovoid(inst,machine)
	if machine.components.electric then
		machine:RemoveTag("wirespot")
		machine.components.electric:RewireAll()
		machine.components.electric:Rewire()
	elseif machine.components.inventoryitem and machine.components.container then
	print("test")
		machine.periodicvoid = machine:DoPeriodicTask(2,trycharge)
	end
end

local function undovoid(inst,machine)
	if machine.components.electric then
		machine:AddTag("wirespot")
		machine.components.electric:RewireAll()
		machine.components.electric:Rewire()
	elseif machine.periodicvoid then
		machine.periodicvoid:Cancel()
	end
end
]]

local function track(inst,machine)
	if machine.components.electric then
		machine.components.electric.showvolt = "TRACE"
	end
end

local function untrack(inst,machine)
	if machine.components.electric and machine.components.electric.showvolt == "TRACE" then
		machine.components.electric.showvolt = false
	end
end

local function tracefn()
	local inst = commonfn()
	
	inst.AnimState:PlayAnimation("upg3")
	inst.components.inventoryitem.imagename = "chip_void"
	inst.components.inventoryitem.atlasname = "images/chip.xml"
	
	inst.type = "trace"
	inst.chipfn = track
	inst.offfn = untrack
	
	return inst
end

return Prefab("common/inventory/upgrade_speed",speedfn,assets),
		Prefab("common/inventory/upgrade_cheap",cheapfn,assets),
		Prefab("common/inventory/upgrade_void",tracefn,assets)